/* Copyright 1998-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

#ifndef MBAUM_H
#define MBAUM_H

typedef void MSGOUTPUT(char *msg);

#ifdef __cplusplus
extern "C" {
#endif

void mfward(int nstate, int nar, int nfir, int nmetastate, 
            int **metastate, int ndata, double *pr, double **a,
            double **b, double **alpha, double *scale);
void mbward(int nstate, int nar, int nfir, int nmetastate,
            int **metastate, int ndata, double **a, double **b,
            double *scale, double **beta);
void mbaum(int ndata, float *data, int nstate, double **a, int nmetastate, int **metastate, 
           double *pr, int namp, double *amp, double *xms, int nar, double **ar, 
           int nfir, double *fir, double *fret, int *state_out, MSGOUTPUT msgoutput, int *processflag);

#ifdef __cplusplus
}
#endif

#endif
